| AI Engine Intrinsics User Guide (AIE) v2025.2

Loading...
Searching...
No Matches
Functions
Z buffer conjugation
Intrinsics » Vector Operations » MAC intrinsics » Multiplication » Advanced » Integer » Vector MAC with pre-adding » 32 bit x 16 bit » 32 bit Complex x 16 bit Complex

## Overview

32 bit complex by 16 bit complex using Z buffer conjugation

## Functions
v4cacc80 | lmac4_sym_nc (v4cacc80 acc, v16cint32 xbuff, int xstart, unsigned int xoffsets, int ystart, v8cint16 zbuff, int zstart, unsigned int zoffsets)
| Complex symetric multiply-accumulate intrinsic function with z buffer conjugation with pre-add from x input buffer .
v4cacc80 | lmac4_sym_nc (v4cacc80 acc, v8cint32 xbuff, int xstart, unsigned int xoffsets, int ystart, v8cint16 zbuff, int zstart, unsigned int zoffsets)
| Complex symetric multiply-accumulate intrinsic function with z buffer conjugation with pre-add from x input buffer using small X input buffer.
v4cacc80 | lmac4_sym_nc (v4cacc80 acc, v8cint32 xbuff, int xstart, unsigned int xoffsets, v8cint32 ybuff, int ystart, v8cint16 zbuff, int zstart, unsigned int zoffsets)
| Complex symetric multiply-accumulate intrinsic function with z buffer conjugation with pre-add from x and y input buffers using small X input buffer.
v4cacc80 | lmsc4_sym_nc (v4cacc80 acc, v16cint32 xbuff, int xstart, unsigned int xoffsets, int ystart, v8cint16 zbuff, int zstart, unsigned int zoffsets)
| Complex symetric multiply-subtract intrinsic function with z buffer conjugation with pre-add from x input buffer .
v4cacc80 | lmsc4_sym_nc (v4cacc80 acc, v8cint32 xbuff, int xstart, unsigned int xoffsets, int ystart, v8cint16 zbuff, int zstart, unsigned int zoffsets)
| Complex symetric multiply-subtract intrinsic function with z buffer conjugation with pre-add from x input buffer using small X input buffer.
v4cacc80 | lmsc4_sym_nc (v4cacc80 acc, v8cint32 xbuff, int xstart, unsigned int xoffsets, v8cint32 ybuff, int ystart, v8cint16 zbuff, int zstart, unsigned int zoffsets)
| Complex symetric multiply-subtract intrinsic function with z buffer conjugation with pre-add from x and y input buffers using small X input buffer.
v4cacc80 | lmul4_sym_nc (v16cint32 xbuff, int xstart, unsigned int xoffsets, int ystart, v8cint16 zbuff, int zstart, unsigned int zoffsets)
| Complex symetric multiply intrinsic function with z buffer conjugation with pre-add from x input buffer .
v4cacc80 | lmul4_sym_nc (v8cint32 xbuff, int xstart, unsigned int xoffsets, int ystart, v8cint16 zbuff, int zstart, unsigned int zoffsets)
| Complex symetric multiply intrinsic function with z buffer conjugation with pre-add from x input buffer using small X input buffer.
v4cacc80 | lmul4_sym_nc (v8cint32 xbuff, int xstart, unsigned int xoffsets, v8cint32 ybuff, int ystart, v8cint16 zbuff, int zstart, unsigned int zoffsets)
| Complex symetric multiply intrinsic function with z buffer conjugation with pre-add from x and y input buffers using small X input buffer.
v4cacc80 | lnegmul4_sym_nc (v16cint32 xbuff, int xstart, unsigned int xoffsets, int ystart, v8cint16 zbuff, int zstart, unsigned int zoffsets)
| Complex symetric multiply-negate intrinsic function with z buffer conjugation with pre-add from x input buffer .
v4cacc80 | lnegmul4_sym_nc (v8cint32 xbuff, int xstart, unsigned int xoffsets, int ystart, v8cint16 zbuff, int zstart, unsigned int zoffsets)
| Complex symetric multiply-negate intrinsic function with z buffer conjugation with pre-add from x input buffer using small X input buffer.
v4cacc80 | lnegmul4_sym_nc (v8cint32 xbuff, int xstart, unsigned int xoffsets, v8cint32 ybuff, int ystart, v8cint16 zbuff, int zstart, unsigned int zoffsets)
| Complex symetric multiply-negate intrinsic function with z buffer conjugation with pre-add from x and y input buffers using small X input buffer.
v4cacc48 | mac4_sym_nc (v4cacc48 acc, v16cint32 xbuff, int xstart, unsigned int xoffsets, int ystart, v8cint16 zbuff, int zstart, unsigned int zoffsets)
| Complex symetric multiply-accumulate intrinsic function with z buffer conjugation with pre-add from x input buffer .
v4cacc48 | mac4_sym_nc (v4cacc48 acc, v8cint32 xbuff, int xstart, unsigned int xoffsets, int ystart, v8cint16 zbuff, int zstart, unsigned int zoffsets)
| Complex symetric multiply-accumulate intrinsic function with z buffer conjugation with pre-add from x input buffer using small X input buffer.
v4cacc48 | mac4_sym_nc (v4cacc48 acc, v8cint32 xbuff, int xstart, unsigned int xoffsets, v8cint32 ybuff, int ystart, v8cint16 zbuff, int zstart, unsigned int zoffsets)
| Complex symetric multiply-accumulate intrinsic function with z buffer conjugation with pre-add from x and y input buffers using small X input buffer.
v4cacc48 | msc4_sym_nc (v4cacc48 acc, v16cint32 xbuff, int xstart, unsigned int xoffsets, int ystart, v8cint16 zbuff, int zstart, unsigned int zoffsets)
| Complex symetric multiply-subtract intrinsic function with z buffer conjugation with pre-add from x input buffer .
v4cacc48 | msc4_sym_nc (v4cacc48 acc, v8cint32 xbuff, int xstart, unsigned int xoffsets, int ystart, v8cint16 zbuff, int zstart, unsigned int zoffsets)
| Complex symetric multiply-subtract intrinsic function with z buffer conjugation with pre-add from x input buffer using small X input buffer.
v4cacc48 | msc4_sym_nc (v4cacc48 acc, v8cint32 xbuff, int xstart, unsigned int xoffsets, v8cint32 ybuff, int ystart, v8cint16 zbuff, int zstart, unsigned int zoffsets)
| Complex symetric multiply-subtract intrinsic function with z buffer conjugation with pre-add from x and y input buffers using small X input buffer.
v4cacc48 | mul4_sym_nc (v16cint32 xbuff, int xstart, unsigned int xoffsets, int ystart, v8cint16 zbuff, int zstart, unsigned int zoffsets)
| Complex symetric multiply intrinsic function with z buffer conjugation with pre-add from x input buffer .
v4cacc48 | mul4_sym_nc (v8cint32 xbuff, int xstart, unsigned int xoffsets, int ystart, v8cint16 zbuff, int zstart, unsigned int zoffsets)
| Complex symetric multiply intrinsic function with z buffer conjugation with pre-add from x input buffer using small X input buffer.
v4cacc48 | mul4_sym_nc (v8cint32 xbuff, int xstart, unsigned int xoffsets, v8cint32 ybuff, int ystart, v8cint16 zbuff, int zstart, unsigned int zoffsets)
| Complex symetric multiply intrinsic function with z buffer conjugation with pre-add from x and y input buffers using small X input buffer.
v4cacc48 | negmul4_sym_nc (v16cint32 xbuff, int xstart, unsigned int xoffsets, int ystart, v8cint16 zbuff, int zstart, unsigned int zoffsets)
| Complex symetric multiply-negate intrinsic function with z buffer conjugation with pre-add from x input buffer .
v4cacc48 | negmul4_sym_nc (v8cint32 xbuff, int xstart, unsigned int xoffsets, int ystart, v8cint16 zbuff, int zstart, unsigned int zoffsets)
| Complex symetric multiply-negate intrinsic function with z buffer conjugation with pre-add from x input buffer using small X input buffer.
v4cacc48 | negmul4_sym_nc (v8cint32 xbuff, int xstart, unsigned int xoffsets, v8cint32 ybuff, int ystart, v8cint16 zbuff, int zstart, unsigned int zoffsets)
| Complex symetric multiply-negate intrinsic function with z buffer conjugation with pre-add from x and y input buffers using small X input buffer.

## Function Documentation

## ◆ lmac4_sym_nc() [1/3]

v4cacc80 lmac4_sym_nc | ( | v4cacc80 | acc,
|  | v16cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | ystart,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets
| ) |  |

Complex symetric multiply-accumulate intrinsic function with z buffer conjugation with pre-add from x input buffer .

acc0 += cnj(z00)*(x00 + y00)
acc1 += cnj(z10)*(x10 + y10)
acc2 += cnj(z20)*(x20 + y20)
acc3 += cnj(z30)*(x30 + y30)

Returns
  Returned accumulation vector (4 x cint80 lanes)

Parameters

  acc | Incoming accumulation vector (4 x cint80 lanes)
  xbuff | Input buffer of 16 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to both x and y buffers. LSB apply to first lane
  ystart | Starting position offset applied to all lanes for input from Y buffer.
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ lmac4_sym_nc() [2/3]

v4cacc80 lmac4_sym_nc | ( | v4cacc80 | acc,
|  | v8cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | ystart,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets
| ) |  |

Complex symetric multiply-accumulate intrinsic function with z buffer conjugation with pre-add from x input buffer using small X input buffer.

acc0 += cnj(z00)*(x00 + y00)
acc1 += cnj(z10)*(x10 + y10)
acc2 += cnj(z20)*(x20 + y20)
acc3 += cnj(z30)*(x30 + y30)

Returns
  Returned accumulation vector (4 x cint80 lanes)

Parameters

  acc | Incoming accumulation vector (4 x cint80 lanes)
  xbuff | Input buffer of 8 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to both x and y buffers. LSB apply to first lane
  ystart | Starting position offset applied to all lanes for input from Y buffer.
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ lmac4_sym_nc() [3/3]

v4cacc80 lmac4_sym_nc | ( | v4cacc80 | acc,
|  | v8cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | v8cint32 | ybuff,
|  | int | ystart,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets
| ) |  |

Complex symetric multiply-accumulate intrinsic function with z buffer conjugation with pre-add from x and y input buffers using small X input buffer.

acc0 += cnj(z00)*(x00 + y00)
acc1 += cnj(z10)*(x10 + y10)
acc2 += cnj(z20)*(x20 + y20)
acc3 += cnj(z30)*(x30 + y30)

Returns
  Returned accumulation vector (4 x cint80 lanes)

Parameters

  acc | Incoming accumulation vector (4 x cint80 lanes)
  xbuff | Input buffer of 8 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to both x and y buffers. LSB apply to first lane
  ybuff | Right input buffer of 8 elements of type cint32
  ystart | Starting position offset applied to all lanes for input from Y buffer.
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ lmsc4_sym_nc() [1/3]

v4cacc80 lmsc4_sym_nc | ( | v4cacc80 | acc,
|  | v16cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | ystart,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets
| ) |  |

Complex symetric multiply-subtract intrinsic function with z buffer conjugation with pre-add from x input buffer .

acc0 -= cnj(z00)*(x00 + y00)
acc1 -= cnj(z10)*(x10 + y10)
acc2 -= cnj(z20)*(x20 + y20)
acc3 -= cnj(z30)*(x30 + y30)

Returns
  Returned accumulation vector (4 x cint80 lanes)

Parameters

  acc | Incoming accumulation vector (4 x cint80 lanes)
  xbuff | Input buffer of 16 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to both x and y buffers. LSB apply to first lane
  ystart | Starting position offset applied to all lanes for input from Y buffer.
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ lmsc4_sym_nc() [2/3]

v4cacc80 lmsc4_sym_nc | ( | v4cacc80 | acc,
|  | v8cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | ystart,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets
| ) |  |

Complex symetric multiply-subtract intrinsic function with z buffer conjugation with pre-add from x input buffer using small X input buffer.

acc0 -= cnj(z00)*(x00 + y00)
acc1 -= cnj(z10)*(x10 + y10)
acc2 -= cnj(z20)*(x20 + y20)
acc3 -= cnj(z30)*(x30 + y30)

Returns
  Returned accumulation vector (4 x cint80 lanes)

Parameters

  acc | Incoming accumulation vector (4 x cint80 lanes)
  xbuff | Input buffer of 8 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to both x and y buffers. LSB apply to first lane
  ystart | Starting position offset applied to all lanes for input from Y buffer.
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ lmsc4_sym_nc() [3/3]

v4cacc80 lmsc4_sym_nc | ( | v4cacc80 | acc,
|  | v8cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | v8cint32 | ybuff,
|  | int | ystart,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets
| ) |  |

Complex symetric multiply-subtract intrinsic function with z buffer conjugation with pre-add from x and y input buffers using small X input buffer.

acc0 -= cnj(z00)*(x00 + y00)
acc1 -= cnj(z10)*(x10 + y10)
acc2 -= cnj(z20)*(x20 + y20)
acc3 -= cnj(z30)*(x30 + y30)

Returns
  Returned accumulation vector (4 x cint80 lanes)

Parameters

  acc | Incoming accumulation vector (4 x cint80 lanes)
  xbuff | Input buffer of 8 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to both x and y buffers. LSB apply to first lane
  ybuff | Right input buffer of 8 elements of type cint32
  ystart | Starting position offset applied to all lanes for input from Y buffer.
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ lmul4_sym_nc() [1/3]

v4cacc80 lmul4_sym_nc | ( | v16cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | ystart,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets
| ) |  |

Complex symetric multiply intrinsic function with z buffer conjugation with pre-add from x input buffer .

acc0 = cnj(z00)*(x00 + y00)
acc1 = cnj(z10)*(x10 + y10)
acc2 = cnj(z20)*(x20 + y20)
acc3 = cnj(z30)*(x30 + y30)

Returns
  Returned accumulation vector (4 x cint80 lanes)

Parameters

  xbuff | Input buffer of 16 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to both x and y buffers. LSB apply to first lane
  ystart | Starting position offset applied to all lanes for input from Y buffer.
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ lmul4_sym_nc() [2/3]

v4cacc80 lmul4_sym_nc | ( | v8cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | ystart,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets
| ) |  |

Complex symetric multiply intrinsic function with z buffer conjugation with pre-add from x input buffer using small X input buffer.

acc0 = cnj(z00)*(x00 + y00)
acc1 = cnj(z10)*(x10 + y10)
acc2 = cnj(z20)*(x20 + y20)
acc3 = cnj(z30)*(x30 + y30)

Returns
  Returned accumulation vector (4 x cint80 lanes)

Parameters

  xbuff | Input buffer of 8 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to both x and y buffers. LSB apply to first lane
  ystart | Starting position offset applied to all lanes for input from Y buffer.
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ lmul4_sym_nc() [3/3]

v4cacc80 lmul4_sym_nc | ( | v8cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | v8cint32 | ybuff,
|  | int | ystart,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets
| ) |  |

Complex symetric multiply intrinsic function with z buffer conjugation with pre-add from x and y input buffers using small X input buffer.

acc0 = cnj(z00)*(x00 + y00)
acc1 = cnj(z10)*(x10 + y10)
acc2 = cnj(z20)*(x20 + y20)
acc3 = cnj(z30)*(x30 + y30)

Returns
  Returned accumulation vector (4 x cint80 lanes)

Parameters

  xbuff | Input buffer of 8 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to both x and y buffers. LSB apply to first lane
  ybuff | Right input buffer of 8 elements of type cint32
  ystart | Starting position offset applied to all lanes for input from Y buffer.
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ lnegmul4_sym_nc() [1/3]

v4cacc80 lnegmul4_sym_nc | ( | v16cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | ystart,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets
| ) |  |

Complex symetric multiply-negate intrinsic function with z buffer conjugation with pre-add from x input buffer .

acc0 = -( cnj(z00)*(x00 + y00) )
acc1 = -( cnj(z10)*(x10 + y10) )
acc2 = -( cnj(z20)*(x20 + y20) )
acc3 = -( cnj(z30)*(x30 + y30) )

Returns
  Returned accumulation vector (4 x cint80 lanes)

Parameters

  xbuff | Input buffer of 16 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to both x and y buffers. LSB apply to first lane
  ystart | Starting position offset applied to all lanes for input from Y buffer.
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ lnegmul4_sym_nc() [2/3]

v4cacc80 lnegmul4_sym_nc | ( | v8cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | ystart,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets
| ) |  |

Complex symetric multiply-negate intrinsic function with z buffer conjugation with pre-add from x input buffer using small X input buffer.

acc0 = -( cnj(z00)*(x00 + y00) )
acc1 = -( cnj(z10)*(x10 + y10) )
acc2 = -( cnj(z20)*(x20 + y20) )
acc3 = -( cnj(z30)*(x30 + y30) )

Returns
  Returned accumulation vector (4 x cint80 lanes)

Parameters

  xbuff | Input buffer of 8 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to both x and y buffers. LSB apply to first lane
  ystart | Starting position offset applied to all lanes for input from Y buffer.
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ lnegmul4_sym_nc() [3/3]

v4cacc80 lnegmul4_sym_nc | ( | v8cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | v8cint32 | ybuff,
|  | int | ystart,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets
| ) |  |

Complex symetric multiply-negate intrinsic function with z buffer conjugation with pre-add from x and y input buffers using small X input buffer.

acc0 = -( cnj(z00)*(x00 + y00) )
acc1 = -( cnj(z10)*(x10 + y10) )
acc2 = -( cnj(z20)*(x20 + y20) )
acc3 = -( cnj(z30)*(x30 + y30) )

Returns
  Returned accumulation vector (4 x cint80 lanes)

Parameters

  xbuff | Input buffer of 8 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to both x and y buffers. LSB apply to first lane
  ybuff | Right input buffer of 8 elements of type cint32
  ystart | Starting position offset applied to all lanes for input from Y buffer.
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ mac4_sym_nc() [1/3]

v4cacc48 mac4_sym_nc | ( | v4cacc48 | acc,
|  | v16cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | ystart,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets
| ) |  |

Complex symetric multiply-accumulate intrinsic function with z buffer conjugation with pre-add from x input buffer .

acc0 += cnj(z00)*(x00 + y00)
acc1 += cnj(z10)*(x10 + y10)
acc2 += cnj(z20)*(x20 + y20)
acc3 += cnj(z30)*(x30 + y30)

Returns
  Returned accumulation vector (4 x cint48 lanes)

Parameters

  acc | Incoming accumulation vector (4 x cint48 lanes)
  xbuff | Input buffer of 16 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to both x and y buffers. LSB apply to first lane
  ystart | Starting position offset applied to all lanes for input from Y buffer.
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ mac4_sym_nc() [2/3]

v4cacc48 mac4_sym_nc | ( | v4cacc48 | acc,
|  | v8cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | ystart,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets
| ) |  |

Complex symetric multiply-accumulate intrinsic function with z buffer conjugation with pre-add from x input buffer using small X input buffer.

acc0 += cnj(z00)*(x00 + y00)
acc1 += cnj(z10)*(x10 + y10)
acc2 += cnj(z20)*(x20 + y20)
acc3 += cnj(z30)*(x30 + y30)

Returns
  Returned accumulation vector (4 x cint48 lanes)

Parameters

  acc | Incoming accumulation vector (4 x cint48 lanes)
  xbuff | Input buffer of 8 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to both x and y buffers. LSB apply to first lane
  ystart | Starting position offset applied to all lanes for input from Y buffer.
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ mac4_sym_nc() [3/3]

v4cacc48 mac4_sym_nc | ( | v4cacc48 | acc,
|  | v8cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | v8cint32 | ybuff,
|  | int | ystart,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets
| ) |  |

Complex symetric multiply-accumulate intrinsic function with z buffer conjugation with pre-add from x and y input buffers using small X input buffer.

acc0 += cnj(z00)*(x00 + y00)
acc1 += cnj(z10)*(x10 + y10)
acc2 += cnj(z20)*(x20 + y20)
acc3 += cnj(z30)*(x30 + y30)

Returns
  Returned accumulation vector (4 x cint48 lanes)

Parameters

  acc | Incoming accumulation vector (4 x cint48 lanes)
  xbuff | Input buffer of 8 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to both x and y buffers. LSB apply to first lane
  ybuff | Right input buffer of 8 elements of type cint32
  ystart | Starting position offset applied to all lanes for input from Y buffer.
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ msc4_sym_nc() [1/3]

v4cacc48 msc4_sym_nc | ( | v4cacc48 | acc,
|  | v16cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | ystart,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets
| ) |  |

Complex symetric multiply-subtract intrinsic function with z buffer conjugation with pre-add from x input buffer .

acc0 -= cnj(z00)*(x00 + y00)
acc1 -= cnj(z10)*(x10 + y10)
acc2 -= cnj(z20)*(x20 + y20)
acc3 -= cnj(z30)*(x30 + y30)

Returns
  Returned accumulation vector (4 x cint48 lanes)

Parameters

  acc | Incoming accumulation vector (4 x cint48 lanes)
  xbuff | Input buffer of 16 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to both x and y buffers. LSB apply to first lane
  ystart | Starting position offset applied to all lanes for input from Y buffer.
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ msc4_sym_nc() [2/3]

v4cacc48 msc4_sym_nc | ( | v4cacc48 | acc,
|  | v8cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | ystart,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets
| ) |  |

Complex symetric multiply-subtract intrinsic function with z buffer conjugation with pre-add from x input buffer using small X input buffer.

acc0 -= cnj(z00)*(x00 + y00)
acc1 -= cnj(z10)*(x10 + y10)
acc2 -= cnj(z20)*(x20 + y20)
acc3 -= cnj(z30)*(x30 + y30)

Returns
  Returned accumulation vector (4 x cint48 lanes)

Parameters

  acc | Incoming accumulation vector (4 x cint48 lanes)
  xbuff | Input buffer of 8 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to both x and y buffers. LSB apply to first lane
  ystart | Starting position offset applied to all lanes for input from Y buffer.
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ msc4_sym_nc() [3/3]

v4cacc48 msc4_sym_nc | ( | v4cacc48 | acc,
|  | v8cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | v8cint32 | ybuff,
|  | int | ystart,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets
| ) |  |

Complex symetric multiply-subtract intrinsic function with z buffer conjugation with pre-add from x and y input buffers using small X input buffer.

acc0 -= cnj(z00)*(x00 + y00)
acc1 -= cnj(z10)*(x10 + y10)
acc2 -= cnj(z20)*(x20 + y20)
acc3 -= cnj(z30)*(x30 + y30)

Returns
  Returned accumulation vector (4 x cint48 lanes)

Parameters

  acc | Incoming accumulation vector (4 x cint48 lanes)
  xbuff | Input buffer of 8 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to both x and y buffers. LSB apply to first lane
  ybuff | Right input buffer of 8 elements of type cint32
  ystart | Starting position offset applied to all lanes for input from Y buffer.
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ mul4_sym_nc() [1/3]

v4cacc48 mul4_sym_nc | ( | v16cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | ystart,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets
| ) |  |

Complex symetric multiply intrinsic function with z buffer conjugation with pre-add from x input buffer .

acc0 = cnj(z00)*(x00 + y00)
acc1 = cnj(z10)*(x10 + y10)
acc2 = cnj(z20)*(x20 + y20)
acc3 = cnj(z30)*(x30 + y30)

Returns
  Returned accumulation vector (4 x cint48 lanes)

Parameters

  xbuff | Input buffer of 16 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to both x and y buffers. LSB apply to first lane
  ystart | Starting position offset applied to all lanes for input from Y buffer.
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ mul4_sym_nc() [2/3]

v4cacc48 mul4_sym_nc | ( | v8cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | ystart,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets
| ) |  |

Complex symetric multiply intrinsic function with z buffer conjugation with pre-add from x input buffer using small X input buffer.

acc0 = cnj(z00)*(x00 + y00)
acc1 = cnj(z10)*(x10 + y10)
acc2 = cnj(z20)*(x20 + y20)
acc3 = cnj(z30)*(x30 + y30)

Returns
  Returned accumulation vector (4 x cint48 lanes)

Parameters

  xbuff | Input buffer of 8 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to both x and y buffers. LSB apply to first lane
  ystart | Starting position offset applied to all lanes for input from Y buffer.
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ mul4_sym_nc() [3/3]

v4cacc48 mul4_sym_nc | ( | v8cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | v8cint32 | ybuff,
|  | int | ystart,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets
| ) |  |

Complex symetric multiply intrinsic function with z buffer conjugation with pre-add from x and y input buffers using small X input buffer.

acc0 = cnj(z00)*(x00 + y00)
acc1 = cnj(z10)*(x10 + y10)
acc2 = cnj(z20)*(x20 + y20)
acc3 = cnj(z30)*(x30 + y30)

Returns
  Returned accumulation vector (4 x cint48 lanes)

Parameters

  xbuff | Input buffer of 8 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to both x and y buffers. LSB apply to first lane
  ybuff | Right input buffer of 8 elements of type cint32
  ystart | Starting position offset applied to all lanes for input from Y buffer.
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ negmul4_sym_nc() [1/3]

v4cacc48 negmul4_sym_nc | ( | v16cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | ystart,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets
| ) |  |

Complex symetric multiply-negate intrinsic function with z buffer conjugation with pre-add from x input buffer .

acc0 = -( cnj(z00)*(x00 + y00) )
acc1 = -( cnj(z10)*(x10 + y10) )
acc2 = -( cnj(z20)*(x20 + y20) )
acc3 = -( cnj(z30)*(x30 + y30) )

Returns
  Returned accumulation vector (4 x cint48 lanes)

Parameters

  xbuff | Input buffer of 16 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to both x and y buffers. LSB apply to first lane
  ystart | Starting position offset applied to all lanes for input from Y buffer.
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ negmul4_sym_nc() [2/3]

v4cacc48 negmul4_sym_nc | ( | v8cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | ystart,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets
| ) |  |

Complex symetric multiply-negate intrinsic function with z buffer conjugation with pre-add from x input buffer using small X input buffer.

acc0 = -( cnj(z00)*(x00 + y00) )
acc1 = -( cnj(z10)*(x10 + y10) )
acc2 = -( cnj(z20)*(x20 + y20) )
acc3 = -( cnj(z30)*(x30 + y30) )

Returns
  Returned accumulation vector (4 x cint48 lanes)

Parameters

  xbuff | Input buffer of 8 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to both x and y buffers. LSB apply to first lane
  ystart | Starting position offset applied to all lanes for input from Y buffer.
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ negmul4_sym_nc() [3/3]

v4cacc48 negmul4_sym_nc | ( | v8cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | v8cint32 | ybuff,
|  | int | ystart,
|  | v8cint16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets
| ) |  |

Complex symetric multiply-negate intrinsic function with z buffer conjugation with pre-add from x and y input buffers using small X input buffer.

acc0 = -( cnj(z00)*(x00 + y00) )
acc1 = -( cnj(z10)*(x10 + y10) )
acc2 = -( cnj(z20)*(x20 + y20) )
acc3 = -( cnj(z30)*(x30 + y30) )

Returns
  Returned accumulation vector (4 x cint48 lanes)

Parameters

  xbuff | Input buffer of 8 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to both x and y buffers. LSB apply to first lane
  ybuff | Right input buffer of 8 elements of type cint32
  ystart | Starting position offset applied to all lanes for input from Y buffer.
  zbuff | Input buffer of 8 elements of type cint16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.